
/*uradjeno je AVL stablo dok se ne unese 0*/
#include <stdio.h>
#include <stdlib.h>

struct drvo
{
int podatak;
int balans;
struct drvo *levi,*desni;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

int dubina(struct drvo *p)
{
int dl=0,dd=0;
if(p)
 {
  if (p->levi) dl=dubina(p->levi);
  if (p->desni) dd=dubina(p->desni);
  if (dl>dd) return ++dl;
  else return ++dd;
 }
else return 0;
}

void lrotacija(struct drvo **m)
{

struct drvo *poml;
struct drvo *pomd;
int stari_balans;
poml = *m;
pomd = poml->desni;
poml->desni = pomd->levi;
pomd->levi = poml;
*m=pomd;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo **m)
{
struct drvo *poml,*pomd;
int stari_balans;
pomd = *m;
poml = pomd->levi;
pomd->levi = poml->desni;
poml->desni = pomd;
*m=poml;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(struct drvo **p, int vrednost)
{
int inkrement, rezultat;
struct drvo *m = *p;
rezultat = 0;
if(m==NULL){
novi(m);
if(m==NULL){
printf("Greska pri alociranju memorije\n");
exit(0);
}
m->podatak = vrednost;
m->levi = m->desni = NULL;
m->balans = 0;
rezultat = 1;
}
else
{
 if(vrednost > m->podatak) inkrement=dodaj(&(m->desni),vrednost);
 else inkrement=-dodaj(&(m->levi),vrednost);
 m->balans += inkrement;
 if(inkrement!=0 && m->balans!=0){
 if(m->balans<-1 ){
 if(m->levi->balans<0) drotacija(&m);
else
{
lrotacija(&(m->levi)); drotacija(&m);}
}
else if(m->balans>1)
{
if(m->desni->balans>0 ) lrotacija(&m);
else
 {
 drotacija(&(m->desni)); lrotacija(&m);
 }
}
else rezultat = 1;
}
}
*p = m;
return rezultat;
}
struct drvo* form(){
struct drvo *koren;
int k;
koren=NULL;
printf("unesi elemente :\n");
scanf("%d",&k);
while(k) 
{
dodaj(&koren,k);
scanf("%d",&k);
}
return koren;
}
void ispis(struct drvo *p)
{
if (p) 
{
 ispis(p->levi);
 printf("%5d",p->podatak);
 ispis(p->desni);
 }
}
main()
{
struct drvo *p;
int n,m;
p=form();
ispis(p);
}