#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

struct drvo {
int balans,broj;
struct drvo *levi,*desni;};

#define novi(x) x=(struct drvo *) malloc(sizeof (struct drvo))

int dubina(struct drvo *p) {
int dl=0,dd=0;
if(p) {
   if(p->levi) dl=dubina(p->levi);
   if(p->desni)  dd=dubina(p->desni);
   if(dl > dd) return ++dl;
   else return ++dd;
   }
   else return 0 ;
}

 void lrotacija (struct drvo **t){
     struct drvo *pomd,*poml;
     int stari_balans;
     poml=*t;
     pomd=poml->desni;
     poml->desni=pomd->levi;
     pomd->levi=poml;
    *t=pomd;

poml->balans=dubina(poml->desni) - dubina (poml->levi);
pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
}


void drotacija(struct drvo **t){
struct drvo *poml,*pomd;
int stari_balans;

pomd=*t;
poml=pomd->levi;
pomd->levi=poml->desni;
poml->desni=pomd;
*t=poml;

poml->balans=dubina(poml->desni) - dubina(poml->levi);
pomd->balans=dubina(pomd->desni) - dubina (pomd->levi);
}

int dodaj(struct drvo **p, int vrednost){
  int inkrement, rezultat;
  struct drvo *t = *p;
  rezultat = 0;
  if(t==NULL){
       novi(t);
       if(t==NULL){
              printf("Greska pri alociranju memorije\n");
               exit(0);
       }
       t->broj = vrednost;
       t->levi = t->desni = NULL;
       t->balans = 0;
       rezultat = 1;
  }
                                                           
 else {
        if(vrednost > t->broj) inkrement=dodaj(&(t->desni),vrednost);
        else inkrement=-dodaj(&(t->levi),vrednost);
        t->balans += inkrement;
        if(inkrement!=0 && t->balans!=0){
               if(t->balans<-1 ){
                       if(t->levi->balans<0) drotacija(&t);
                       else{ lrotacija(&(t->levi)); drotacija(&t); }
               }
               else if(t->balans>1){
                       if(t->desni->balans>0 ) lrotacija(&t);
                       else{ drotacija(&(t->desni)); lrotacija(&t);
               }
               else rezultat = 1;
        }
  }
  *p = t;
  return rezultat;
}

void ispis(struct drvo *p){
if(p) {
ispis(p->levi);
printf("%5d \n",p->broj);
printf("%5d \n",p->balans);
ispis(p->desni);
    }
 }  


struct drvo* form() {
struct drvo *koren;
int i,k,n;
koren=NULL;
printf("unesi broj elemenata \n");
scanf("%d",&n);
for(i=0;i<n;i++){
  scanf("%d", &k);
  dodaj(&koren,k); 
}
return koren;
}

void sredi(struct drvo **p){
  struct drvo *t;
  if(*p){
        t=*p;
        if( t->balans<-1 ){
               if( t->levi->balans<0 ) drotacija(&t);
               else{
                       lrotacija(&(t->levi)); drotacija(&t);
               }
        }
        else if( t->balans>1 ){
               if( t->desni->balans>0 ) lrotacija(&t);
               else{
                       drotacija(&(t->desni)); lrotacija(&t);
               }
        }
  *p=t;
  }
}


  


struct drvo* obrisi_b(struct drvo *p,int k){
  struct drvo *pom;
  if(!p) return NULL;
  if (p->broj==k) {
       if((!p->levi) && (!p->desni)) {
               free(p);
               return NULL;
       }
       if((!p->levi) && (p->desni)) {
               pom=p->desni;
               free(p);
               return pom;
       }
       if((p->levi) && (!p->desni)){
               pom=p->levi;
               free(p);
               return pom;
       }
        if((p->levi) && (p->desni)){
               p->broj=nadji(&(p->desni));
               p->balans=dubina(p->desni)-dubina(p->levi);
               sredi(&p);
               return p;
        }
  }
  if(k<p->broj){
        p->levi=obrisi_b(p->levi,k);
        p->balans=dubina(p->desni)-dubina(p->levi);
        sredi(&p);
        return p;
  }
  else{
        p->desni=obrisi_b(p->desni,k);
        p->balans=dubina(p->desni)-dubina(p->levi);
        sredi(&p);
        return p;
  }
}

int nadji(struct drvo **p){
  struct drvo *pom,*pom1;
  int rez;
  pom=*p;
  if (!pom->levi) {
       rez=pom->broj;
       pom=pom->desni;
  }
  else rez=nadji(&(pom->levi));
  if (pom) {
       pom->balans=dubina(pom->desni)-dubina(pom->levi);
       sredi(&pom);
  }
  *p=pom;
  return rez;
}



main() {
struct drvo *p,*qq;
int q,k;
p=form();
ispis (p);
q=dubina(p);
qq=p;
printf("Dubina je %d \n",q);
printf("Unesite za brisanje\n");
scanf("%d \n",&k);
printf("Pre brisanja :");
ispis(p)
obrisi_b(qq,k);
printf("Posle brisanja :");
ispis(p);


}






