#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct predavac{
   char *ime,*zvanje;
   int br_predmeta;
   int radni_staz;
};
struct lista{
   struct predavac *glava;
   struct lista *rep;
};


#define novi(x) x=(struct lista *)malloc(sizeof(struct lista))

void ispis(struct lista *p){
  while(p) {
     printf(" %s ",p->glava->zvanje);
     printf("%s ",p->glava->ime);
     printf("%d %d \n",p->glava->br_predmeta,p->glava->radni_staz);
     p=p->rep;
  }
}



void dodaj_sort(struct lista **p,struct predavac *q){
   struct lista *temp,*res,*pos;
   novi(temp);
   if (!temp){
      printf("Greska pri alokaciji memorije\n");
      exit(0);
   }
   temp->glava=q;
   temp->rep=NULL;
   res=*p;
   if(!res) res=temp;

   else{
      if(strcmp(res->glava->zvanje,q->zvanje)>0) {
         temp->rep=res;
         res=temp;
      }
      else {
         pos=res;
         while((pos->rep) &&
                (strcmp(pos->rep->glava->zvanje,q->zvanje)<0) )
            pos=pos->rep;
         temp->rep=pos->rep;
         pos->rep=temp;
      }
   }

   *p=res;
}

struct predavac* ucitaj_predavaca(){
    struct predavac *st;
    char s[100];
    getchar();
    st=(struct predavac*)malloc(sizeof(struct predavac));
    printf("zvanje: "); scanf("%s",s);
    st->zvanje=(char*)malloc(strlen(s)+1);
    strcpy(st->zvanje,s);
    printf("ime: "); scanf("%s",s);
    st->ime=(char*)malloc(strlen(s)+1);
    strcpy(st->ime,s);
    printf("br_predmeta : ");
 scanf("%d",&st->br_predmeta);
    printf("radni_staz: "); scanf("%d",&st->radni_staz);
    return st;
}

struct lista *form_sort(){
   int i,n;
   struct lista *p;
   struct predavac *q;
   p=NULL;
   scanf("%d",&n);
   for(i=0;i<n;i++){
      q=ucitaj_predavaca();
      printf("Ucitan\n");
      dodaj_sort(&p,q);
   }
   return p;
}



  void brisi(struct lista **p, int x){
	struct lista *res=*p, *pos=res, *temp;
	
	while(pos && (pos->glava->br_predmeta>x)){
		temp=pos;
		res=pos->rep;
		free(pos);
		pos=res;
	}
	
	while(pos && pos->rep)
		if(pos->rep->glava->br_predmeta>x){
			temp=pos->rep;
			pos->rep=temp->rep;
			free(temp);
		}
		else pos=pos->rep;
	
	*p=res;
}

main(){
   struct lista *p=NULL;
char a[100];
int g;

   p=form_sort();
   ispis(p);
   printf("unesi broj predmeta na osnovu koga ce se vrsiti brisanje: \n");
   scanf("%d",&g);
   brisi(&p,g);
   printf(" ispis posle brisanja \n");
   ispis(p);
}

     
