#include<stdio.h>
#include<string.h>
#include<math.h>
#include<stdlib.h>

struct predavac{
	char *ime,*zvanje;
	int br_pred,staz;
	};

struct lista{
   struct predavac *glava;
   struct lista *rep;
};

#define novi(t) t=(struct lista *)malloc(sizeof(struct lista))
#define novii(x) x=(struct predavac *)malloc(sizeof(struct lista))

void ispis(struct lista *p){
  while(p) {
     printf("%s %s ",p->glava->ime,p->glava->zvanje);
     printf("%d %d\n",p->glava->br_pred,p->glava->staz);
     p=p->rep;
  }
}

struct predavac* ucitaj_predavaca(){
    struct predavac *pr;
    char s[100];
    getchar();
    pr=(struct predavac* )malloc(sizeof(struct predavac));
    printf("Ime: "); scanf("%s",s);
    pr->ime=(char*)malloc(strlen(s)+1);
    strcpy(pr->ime,s);
    printf("zvanje: "); scanf("%s",s);
    pr->zvanje=(char*)malloc(strlen(s)+1);
    strcpy(pr->zvanje,s);
    printf("Broj predmeta: "); 
    scanf("%d",&pr->br_pred);
    printf("Godina staza: "); scanf("%d",&pr->staz);
    return pr;
}

void dodaj_sort(struct lista **p,struct predavac *q){
   struct lista *temp,*res,*pos;
   novi(temp);
   if (!temp){
      printf("Greska pri alokaciji memorije\n");
      exit(0);				
   }
   temp->glava=q;
   temp->rep=NULL;
   res=*p;
   if(!res) res=temp;
   else{
      if((strcmp(res->glava->ime,q->ime)>0) ){  
         temp->rep=res;
         res=temp;
      }
      else {
         pos=res;
         while((pos->rep) &&
                (strcmp(pos->rep->glava->ime,q->ime)<0) 
                   )
            pos=pos->rep;
         temp->rep=pos->rep;
         pos->rep=temp;
      }					
   }
   *p=res;
}				


void obrisi(struct lista **p,int x){
	struct lista *res=*p, *pos=res, *temp;
	while(pos && pos->glava->br_pred <x){
		temp=pos;
		res=pos->rep;
		free(pos);
		pos=res;
	}

	while(pos && pos->rep)
		if(pos->rep->glava->br_pred<x){
			temp=pos->rep;
			pos->rep=temp->rep;
			free(temp);
		}
		else pos=pos->rep;
	*p=res;
}

struct lista *form_sort(){
   int i,n;
   struct lista *p;
   struct predavac *q;
   p=NULL;
   scanf("%d",&n);
   for(i=0;i<n;i++){
      q=ucitaj_predavaca();
      printf("Ucitan\n");
      dodaj_sort(&p,q);
   }
   return p;
}

main(){
   struct lista *p=NULL;
char a[100]; 
int s,k;
   printf("K0liko podataka unosite?\n");
   p=form_sort();
   ispis(p);
   printf("%d \n",s);
   printf("  \n");
   printf("Ucitaj granicu predmeta:\n");
   scanf("%d",&k);
   obrisi(&p,k);
   ispis(p);
}

