#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>

struct drvo{
int broj, balans;
struct drvo *levi, *desni;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

int dubina(struct drvo *p){
int dd=0;
int dl=0;
if(p){
if(p->levi) dl=dubina(p->levi);
if(p->desni) dd=dubina(p->desni);
}
if(dl>dd) return ++dl;
else return ++dd;
}

void lrotacija(struct drvo **p){
struct drvo *poml, *pomd;
poml=*p;
pomd=poml->desni;
poml->desni=pomd->levi;
pomd->levi=poml;
*p=pomd;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo **p){
struct drvo *poml, *pomd;
pomd=*p;
poml=pomd->levi;
pomd->levi=poml->desni;
poml->desni=pomd;
*p=poml;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi); 
}

int dodaj(struct drvo **p, int k){
int inkrement, rezultat;
struct drvo *t=*p;
rezultat=0;
if(t==NULL){
novi(t);
if(t==NULL){
printf("greska\n");
exit(0);
}
t->broj=k;
t->levi=t->desni=NULL;
t->balans=0;
rezultat=1;
}
else{
if(k>t->broj) inkrement=dodaj(&(t->desni),k);
else inkrement=-dodaj(&(t->levi), k);
t->balans+=inkrement;
}
if(inkrement!=0 && t->balans!=0){
if(t->balans<-1){
if(t->levi->balans<0) drotacija(&t);
else{ lrotacija(&(t->levi)); drotacija(&t);}
}
if(t->balans>1){
if(t->desni->balans>0) lrotacija(&t);
else{ drotacija(&(t->desni)); lrotacija(&t);}
}
else rezultat=1;
}
*p=t;
return rezultat;
}

void ispis(struct drvo *p){
if(p){
ispis(p->desni);
printf("%5d", p->broj);
ispis(p->levi);
}
}

struct drvo *nadji(struct drvo *p, int k, struct drvo **q){
struct drvo *pom;
pom=p;
*q=NULL;
if(pom->broj==k){ *q=pom;
return *q;
}
else{
if(pom->broj<k)
while(pom->broj<k)
pom=pom->desni;
*q=pom;
return *q;}
if(pom->broj<k)
while(pom->broj>k)
pom=pom->levi;
*q=pom;
return (*q);
}


int broj(struct drvo *p, int k){
struct drvo *q,*x;
int l=0;
int d=0;
x=nadji(p,k,&q);
if(x){
if (x->levi) l=broj(x->levi, k);
if (x->desni) d=broj(x->desni,k);
}
return (l+d+1);
}


int main(){
struct drvo *p,*q, *x;
int n,i,k,a,m;
p=NULL;
q=NULL;
printf("unesi broj clanova stabla\n");
scanf("%d", &n);
printf("unesi clanove\n");
for(i=1;i<=n;i++){
scanf("%d", &a);
k=dodaj(&p, a);
}
ispis(p);
printf("\n");
scanf("%d", &m);
//x=nadji(p,m,&q);
//ispis(x);
printf("%d", broj(p,m));
}









